const csl = require("@emurgo/cardano-serialization-lib-nodejs");
const lib = require('@mlabs-haskell/csl-gc-wrapper')(csl);

// Explicit re-exports are needed due to how nodejs processes CommonJS imports in ESM.
// If they are dynamic, they are only available via the `default` property of the module.
// Providing them explicitly lets nodejs analyze the module structure and put the
// appropriate entry points to the module interface.

// To re-generate the code below use this snippet:

// for (let key in lib) {
//     if (lib.hasOwnProperty(key)) {
//         module.exports[key] = lib[key];
//         if (!key.startsWith('_'))
//         console.log('module.exports.' + key + ' = lib["'+key+'"];');
//     }
// }

module.exports.encode_json_str_to_plutus_datum = lib["encode_json_str_to_plutus_datum"];
module.exports.decode_plutus_datum_to_json_str = lib["decode_plutus_datum_to_json_str"];
module.exports.encode_arbitrary_bytes_as_metadatum = lib["encode_arbitrary_bytes_as_metadatum"];
module.exports.decode_arbitrary_bytes_from_metadatum = lib["decode_arbitrary_bytes_from_metadatum"];
module.exports.encode_json_str_to_metadatum = lib["encode_json_str_to_metadatum"];
module.exports.decode_metadatum_to_json_str = lib["decode_metadatum_to_json_str"];
module.exports.min_fee = lib["min_fee"];
module.exports.calculate_ex_units_ceil_cost = lib["calculate_ex_units_ceil_cost"];
module.exports.min_script_fee = lib["min_script_fee"];
module.exports.encrypt_with_password = lib["encrypt_with_password"];
module.exports.decrypt_with_password = lib["decrypt_with_password"];
module.exports.create_send_all = lib["create_send_all"];
module.exports.make_daedalus_bootstrap_witness = lib["make_daedalus_bootstrap_witness"];
module.exports.make_icarus_bootstrap_witness = lib["make_icarus_bootstrap_witness"];
module.exports.make_vkey_witness = lib["make_vkey_witness"];
module.exports.hash_auxiliary_data = lib["hash_auxiliary_data"];
module.exports.hash_transaction = lib["hash_transaction"];
module.exports.hash_plutus_data = lib["hash_plutus_data"];
module.exports.hash_script_data = lib["hash_script_data"];
module.exports.get_implicit_input = lib["get_implicit_input"];
module.exports.get_deposit = lib["get_deposit"];
module.exports.min_ada_for_output = lib["min_ada_for_output"];
module.exports.min_ada_required = lib["min_ada_required"];
module.exports.encode_json_str_to_native_script = lib["encode_json_str_to_native_script"];
module.exports.CertificateKind = lib["CertificateKind"];
module.exports.MIRPot = lib["MIRPot"];
module.exports.MIRKind = lib["MIRKind"];
module.exports.RelayKind = lib["RelayKind"];
module.exports.NativeScriptKind = lib["NativeScriptKind"];
module.exports.ScriptHashNamespace = lib["ScriptHashNamespace"];
module.exports.NetworkIdKind = lib["NetworkIdKind"];
module.exports.LanguageKind = lib["LanguageKind"];
module.exports.PlutusDataKind = lib["PlutusDataKind"];
module.exports.RedeemerTagKind = lib["RedeemerTagKind"];
module.exports.PlutusDatumSchema = lib["PlutusDatumSchema"];
module.exports.TransactionMetadatumKind = lib["TransactionMetadatumKind"];
module.exports.MetadataJsonSchema = lib["MetadataJsonSchema"];
module.exports.CoinSelectionStrategyCIP2 = lib["CoinSelectionStrategyCIP2"];
module.exports.StakeCredKind = lib["StakeCredKind"];
module.exports.ScriptSchema = lib["ScriptSchema"];
module.exports.CborContainerType = lib["CborContainerType"];
module.exports.Address = lib["Address"];
module.exports.AssetName = lib["AssetName"];
module.exports.AssetNames = lib["AssetNames"];
module.exports.Assets = lib["Assets"];
module.exports.AuxiliaryData = lib["AuxiliaryData"];
module.exports.AuxiliaryDataHash = lib["AuxiliaryDataHash"];
module.exports.AuxiliaryDataSet = lib["AuxiliaryDataSet"];
module.exports.BaseAddress = lib["BaseAddress"];
module.exports.BigInt = lib["BigInt"];
module.exports.BigNum = lib["BigNum"];
module.exports.Bip32PrivateKey = lib["Bip32PrivateKey"];
module.exports.Bip32PublicKey = lib["Bip32PublicKey"];
module.exports.Block = lib["Block"];
module.exports.BlockHash = lib["BlockHash"];
module.exports.BootstrapWitness = lib["BootstrapWitness"];
module.exports.BootstrapWitnesses = lib["BootstrapWitnesses"];
module.exports.ByronAddress = lib["ByronAddress"];
module.exports.Certificate = lib["Certificate"];
module.exports.Certificates = lib["Certificates"];
module.exports.ConstrPlutusData = lib["ConstrPlutusData"];
module.exports.CostModel = lib["CostModel"];
module.exports.Costmdls = lib["Costmdls"];
module.exports.DNSRecordAorAAAA = lib["DNSRecordAorAAAA"];
module.exports.DNSRecordSRV = lib["DNSRecordSRV"];
module.exports.DataCost = lib["DataCost"];
module.exports.DataHash = lib["DataHash"];
module.exports.DatumSource = lib["DatumSource"];
module.exports.Ed25519KeyHash = lib["Ed25519KeyHash"];
module.exports.Ed25519KeyHashes = lib["Ed25519KeyHashes"];
module.exports.Ed25519Signature = lib["Ed25519Signature"];
module.exports.EnterpriseAddress = lib["EnterpriseAddress"];
module.exports.ExUnitPrices = lib["ExUnitPrices"];
module.exports.ExUnits = lib["ExUnits"];
module.exports.FixedTransaction = lib["FixedTransaction"];
module.exports.GeneralTransactionMetadata = lib["GeneralTransactionMetadata"];
module.exports.GenesisDelegateHash = lib["GenesisDelegateHash"];
module.exports.GenesisHash = lib["GenesisHash"];
module.exports.GenesisHashes = lib["GenesisHashes"];
module.exports.GenesisKeyDelegation = lib["GenesisKeyDelegation"];
module.exports.Header = lib["Header"];
module.exports.HeaderBody = lib["HeaderBody"];
module.exports.InputWithScriptWitness = lib["InputWithScriptWitness"];
module.exports.InputsWithScriptWitness = lib["InputsWithScriptWitness"];
module.exports.Int = lib["Int"];
module.exports.Ipv4 = lib["Ipv4"];
module.exports.Ipv6 = lib["Ipv6"];
module.exports.KESSignature = lib["KESSignature"];
module.exports.KESVKey = lib["KESVKey"];
module.exports.Language = lib["Language"];
module.exports.Languages = lib["Languages"];
module.exports.LegacyDaedalusPrivateKey = lib["LegacyDaedalusPrivateKey"];
module.exports.LinearFee = lib["LinearFee"];
module.exports.MIRToStakeCredentials = lib["MIRToStakeCredentials"];
module.exports.MetadataList = lib["MetadataList"];
module.exports.MetadataMap = lib["MetadataMap"];
module.exports.Mint = lib["Mint"];
module.exports.MintAssets = lib["MintAssets"];
module.exports.MintBuilder = lib["MintBuilder"];
module.exports.MintWitness = lib["MintWitness"];
module.exports.MintsAssets = lib["MintsAssets"];
module.exports.MoveInstantaneousReward = lib["MoveInstantaneousReward"];
module.exports.MoveInstantaneousRewardsCert = lib["MoveInstantaneousRewardsCert"];
module.exports.MultiAsset = lib["MultiAsset"];
module.exports.MultiHostName = lib["MultiHostName"];
module.exports.NativeScript = lib["NativeScript"];
module.exports.NativeScripts = lib["NativeScripts"];
module.exports.NetworkId = lib["NetworkId"];
module.exports.NetworkInfo = lib["NetworkInfo"];
module.exports.Nonce = lib["Nonce"];
module.exports.OperationalCert = lib["OperationalCert"];
module.exports.PlutusData = lib["PlutusData"];
module.exports.PlutusList = lib["PlutusList"];
module.exports.PlutusMap = lib["PlutusMap"];
module.exports.PlutusScript = lib["PlutusScript"];
module.exports.PlutusScriptSource = lib["PlutusScriptSource"];
module.exports.PlutusScripts = lib["PlutusScripts"];
module.exports.PlutusWitness = lib["PlutusWitness"];
module.exports.PlutusWitnesses = lib["PlutusWitnesses"];
module.exports.Pointer = lib["Pointer"];
module.exports.PointerAddress = lib["PointerAddress"];
module.exports.PoolMetadata = lib["PoolMetadata"];
module.exports.PoolMetadataHash = lib["PoolMetadataHash"];
module.exports.PoolParams = lib["PoolParams"];
module.exports.PoolRegistration = lib["PoolRegistration"];
module.exports.PoolRetirement = lib["PoolRetirement"];
module.exports.PrivateKey = lib["PrivateKey"];
module.exports.ProposedProtocolParameterUpdates = lib["ProposedProtocolParameterUpdates"];
module.exports.ProtocolParamUpdate = lib["ProtocolParamUpdate"];
module.exports.ProtocolVersion = lib["ProtocolVersion"];
module.exports.PublicKey = lib["PublicKey"];
module.exports.PublicKeys = lib["PublicKeys"];
module.exports.Redeemer = lib["Redeemer"];
module.exports.RedeemerTag = lib["RedeemerTag"];
module.exports.Redeemers = lib["Redeemers"];
module.exports.Relay = lib["Relay"];
module.exports.Relays = lib["Relays"];
module.exports.RewardAddress = lib["RewardAddress"];
module.exports.RewardAddresses = lib["RewardAddresses"];
module.exports.ScriptAll = lib["ScriptAll"];
module.exports.ScriptAny = lib["ScriptAny"];
module.exports.ScriptDataHash = lib["ScriptDataHash"];
module.exports.ScriptHash = lib["ScriptHash"];
module.exports.ScriptHashes = lib["ScriptHashes"];
module.exports.ScriptNOfK = lib["ScriptNOfK"];
module.exports.ScriptPubkey = lib["ScriptPubkey"];
module.exports.ScriptRef = lib["ScriptRef"];
module.exports.SingleHostAddr = lib["SingleHostAddr"];
module.exports.SingleHostName = lib["SingleHostName"];
module.exports.StakeCredential = lib["StakeCredential"];
module.exports.StakeCredentials = lib["StakeCredentials"];
module.exports.StakeDelegation = lib["StakeDelegation"];
module.exports.StakeDeregistration = lib["StakeDeregistration"];
module.exports.StakeRegistration = lib["StakeRegistration"];
module.exports.Strings = lib["Strings"];
module.exports.TimelockExpiry = lib["TimelockExpiry"];
module.exports.TimelockStart = lib["TimelockStart"];
module.exports.Transaction = lib["Transaction"];
module.exports.TransactionBatch = lib["TransactionBatch"];
module.exports.TransactionBatchList = lib["TransactionBatchList"];
module.exports.TransactionBodies = lib["TransactionBodies"];
module.exports.TransactionBody = lib["TransactionBody"];
module.exports.TransactionBuilder = lib["TransactionBuilder"];
module.exports.TransactionBuilderConfig = lib["TransactionBuilderConfig"];
module.exports.TransactionBuilderConfigBuilder = lib["TransactionBuilderConfigBuilder"];
module.exports.TransactionHash = lib["TransactionHash"];
module.exports.TransactionInput = lib["TransactionInput"];
module.exports.TransactionInputs = lib["TransactionInputs"];
module.exports.TransactionMetadatum = lib["TransactionMetadatum"];
module.exports.TransactionMetadatumLabels = lib["TransactionMetadatumLabels"];
module.exports.TransactionOutput = lib["TransactionOutput"];
module.exports.TransactionOutputAmountBuilder = lib["TransactionOutputAmountBuilder"];
module.exports.TransactionOutputBuilder = lib["TransactionOutputBuilder"];
module.exports.TransactionOutputs = lib["TransactionOutputs"];
module.exports.TransactionUnspentOutput = lib["TransactionUnspentOutput"];
module.exports.TransactionUnspentOutputs = lib["TransactionUnspentOutputs"];
module.exports.TransactionWitnessSet = lib["TransactionWitnessSet"];
module.exports.TransactionWitnessSets = lib["TransactionWitnessSets"];
module.exports.TxBuilderConstants = lib["TxBuilderConstants"];
module.exports.TxInputsBuilder = lib["TxInputsBuilder"];
module.exports.URL = lib["URL"];
module.exports.UnitInterval = lib["UnitInterval"];
module.exports.Update = lib["Update"];
module.exports.VRFCert = lib["VRFCert"];
module.exports.VRFKeyHash = lib["VRFKeyHash"];
module.exports.VRFVKey = lib["VRFVKey"];
module.exports.Value = lib["Value"];
module.exports.Vkey = lib["Vkey"];
module.exports.Vkeys = lib["Vkeys"];
module.exports.Vkeywitness = lib["Vkeywitness"];
module.exports.Vkeywitnesses = lib["Vkeywitnesses"];
module.exports.Withdrawals = lib["Withdrawals"];
